package com.cf.imes.module.system.dal.mysql.machine;

import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.framework.mybatis.core.mapper.BaseMapperX;
import com.cf.imes.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.cf.imes.module.system.controller.admin.machine.vo.MachinePageReqVO;
import com.cf.imes.module.system.dal.dataobject.machine.MachineDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

import static com.cf.imes.framework.security.core.util.SecurityFrameworkUtils.getUserOrganId;

/**
 * 机台 Mapper
 *
 * @author 晨丰科技
 */
@Mapper
public interface MachineMapper extends BaseMapperX<MachineDO> {

    default PageResult<MachineDO> selectPage(MachinePageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<MachineDO>()
                .eq(MachineDO::getOrganId,getUserOrganId())
                .likeIfPresent(MachineDO::getName, reqVO.getName())
                .eqIfPresent(MachineDO::getMachineType, reqVO.getMachineType())
                .betweenIfPresent(MachineDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(MachineDO::getCreateTime));
    }


    default PageResult<MachineDO> selectPage(MachinePageReqVO pageParam, Collection<Long> ids) {
        return selectPage(pageParam, new LambdaQueryWrapperX<MachineDO>()
                .eqIfPresent(MachineDO::getMachineType, pageParam.getMachineType())
                .likeIfPresent(MachineDO::getName, pageParam.getName())
                .betweenIfPresent(MachineDO::getCreateTime, pageParam.getCreateTime())
                .orderByDesc(MachineDO::getCreateTime));
    };



    default List<MachineDO> selectByOrganId(Integer machineType,Long organId) {
        return selectList(new LambdaQueryWrapperX<MachineDO>()
                .eq(MachineDO::getOrganId,organId)
                .eq(MachineDO::getDeleted,false)
                .eq(MachineDO::getMachineType,machineType)
                .select(MachineDO::getId));

    }



    default MachineDO selectMachineName(String name,Integer machineType,Long organId) {
        return selectOne(new LambdaQueryWrapperX<MachineDO>()
                .eq(MachineDO::getOrganId,organId)
                .eq(MachineDO::getDeleted,false)
                .eq(MachineDO::getMachineType,machineType)
                .eq(MachineDO::getName,name));

    }

    MachineDO selectMachine(@Param("name") String name, @Param("machineType") Integer machineType, @Param("machineId") Long machineId, @Param("organId") Long organId);


    default List<MachineDO> selectMachineList(Integer machineType,Long organId) {
        return selectList(new LambdaQueryWrapperX<MachineDO>()
                .eq(MachineDO::getOrganId,organId)
                .eq(MachineDO::getDeleted,false)
                .eq(MachineDO::getMachineType,machineType)
                .select(MachineDO::getId,MachineDO::getName,MachineDO::getMachineType));

    }


    List<MachineDO> selectMachineDataSource(@Param("filed") String filed,@Param("machineId") Long machineId,@Param("organId")  Long organId);
}